#ifndef IMAGES_H
#define IMAGES_H

class ImgObj;
// This class hold all the images the game will use. Does a lot of things that related to them as well
class Images {
public:
	// call in init_data()
	void load();
	// call in clean_data()
	void destroy();
	// dir is 0 for north, 1 for south, 2 for west, 3 for east
	// state is 0 for idle, 1 for walking, 2 for attacking, 3 for hit, 4 for dead
	// type is 0 for gold, 1 for food
	// pos is the position on screen
	// counter is used for figuring out which image to draw
	// returns true if the images is still displayed, otherwise, false (for dead animations)
	bool drawKing(int dir, int state, ol::Vec2D pos, int counter);
	bool drawPeon(int dir, int state, ol::Vec2D pos, int counter);
	void drawItem(int type, ol::Vec2D pos, int counter);
private:
	ImgObj *iKing, *iPeon, *iGold;
};

extern Images images;
#endif
