#ifndef MFOBJECT_H
#define MFOBJECT_H

const int MAP_X = 50;
const int MAP_Y = 50;
extern ol::Vec2D strike_pos;
// Class for all objects
class MFObject {
public:
	// type is 0 for king, 1 for peon, 2 for gold, 3 for food, 5 for king strike, and 6 for peon strike
	// pos is starting position, gold is if they have a bit of gold or not (only used for peons)
	MFObject(int type, ol::Vec2D pos, bool gold = false);
	
	// Execute the functions in the following order
	
	// Do once for every other object. Note: Effects only happen with this object, not the other.
	void doCollide(MFObject *other);
	// For peons, this is the AI, for the king, it's where player control is handled and camera adjectment
	// Also responds to collisions that happened so far
	// return false if the object needs to be removed from the list (peon/king dead, striking done, item picked up)
	bool doLogic(int **map);
	// If a sub object was spawned, this will return it. The class loses it's reference to it when it's done however.
	MFObject *spawnObject() { MFObject *ret = child; child = NULL; return ret;};
	// Draws the object on the screen
	void draw();
	// Following are provided for the main loop for the king
	int health() { return _health; };
	int score() { return _score; };
	int gold() { return num_gold; };
	bool isPeon() { return (_type == 1); };
private:
	int _type;
	ol::Vec2D _pos, speed;
	int state;
	bool hit_played, dead_played;
	float counter;
	int _health, _score, dir, hit, damage, ai_stun;
	int num_gold;
	ol::Vec2D target_pos; // Where the target is at
	MFObject *child;
	bool collide;
	ol::Vec2D collide_vec;
	float collide_angle;
};

#endif
