#include "global.h"
#include "images.h"

using namespace std;
using namespace ol;

Images images;

// Class contains all the images being used for each image type
class ImgObj {
public:
	// type is 0 for king, 1 for peon, 2 for gold, 3 for food
	ImgObj(Bitmap *image, int type) : _image(image), _type(type) {
		//TODO: Until animation is done, just load the image and rotate it, filling all spots
		
		switch(type) {
		case 0:
			// Load king images
			break;
		case 1:
			// Load peon images
			break;
		case 2:
			// Load gold images (only one direction and state)
			break;
		}
	};
	~ImgObj() {
	};
	// dir is 0 for north, 1 for south, 2 for east, 3 for west
	// state is 0 for idle, 1 for walking, 2 for attacking, 3 for hit, 4 for dead
	bool draw(Vec2D pos, int counter, int dir=0, int state = 0) {
		float o = 1.0;
		float r = 0.0;
		switch (dir) {
		case 0:
			r = 0;
			break;
		case 1:
			r = AL_PI;
			break;
		case 2:
			r = AL_PI*3/2;
			break;
		case 3:
			r = AL_PI/2;
		}
		if (state == 4) {
			o = 1.0 - (float)counter/(float)10;
			if (o < 0.0) o = 0.0;
		}
		_image->BlitRotated(pos.x + _image->Width()/2, pos.y + _image->Height()/2, r, o);
		if (o <= 0.0) return false;
		return true;
	};
private:
	Bitmap *_image;
	int _type;
	// [dir][state]
	//list<Bitmap *> images[4][5];
};

void Images::load() {
//*king, *peon, *gold, *food, *weapon, *big_king, *big_gold;
	// Load King images
	iKing = new ImgObj(king, 0);
	// Load peons images
	iPeon = new ImgObj(peon, 1);
	// Load items
	iGold = new ImgObj(gold, 2);
}

void Images::destroy() {
	delete iKing;
	delete iPeon;
	delete iGold;
}

bool Images::drawKing(int dir, int state, Vec2D pos, int counter) {
	return iKing->draw(pos, counter, dir, state);
}

bool Images::drawPeon(int dir, int state, Vec2D pos, int counter) {
	return iPeon->draw(pos, counter, dir, state);
}

void Images::drawItem(int type, Vec2D pos, int counter) {
	switch (type) {
	case 0:
		iGold->draw(pos, counter, 0, 0);
		break;
	}
}

