#include "global.h"
#include "title.h"
#include "images.h"
using namespace ol;

bool title_screen(void) {
	clear_keybuf();
	TextRenderer font("media/OldLondon.ttf", TEXT_X(100), TEXT_Y(100), Rgba::WHITE);
	TextRenderer selection("media/OldLondon.ttf", TEXT_X(50), TEXT_Y(50), Rgba(0.8, 0.8, 0.8));
	TextRenderer selected(selection, TEXT_X(50), TEXT_Y(50), Rgba(1.0, 1.0, 1.0));
	TextRenderer grayed(selection, TEXT_X(50), TEXT_Y(50), Rgba(0.5, 0.5, 0.5, 0.5));
	int item = 0; // 0 for play game, 1 for how to play, and 2 for quit
	bool displaying = true;
	float counter = 0.0;
	FpsCounter::Start(60.0);

	while (displaying) {
		FpsCounter::NewFrameStarted();
		if (keypressed()) {
			int key = readkey() >> 8;
			if (key == KEY_Q) {
				OlLog("Q pressed, quitting");
				return false;
			}
			if (key == KEY_DOWN || key == KEY_S) {
				item++;
				item %= 3;
				if (item == 1) item++;
			}
			if (key == KEY_UP || key == KEY_W) {
				if (item) item--;
				else item = 2;
				if (item == 1) item--;
			}
			if (key == KEY_ENTER) {
				displaying = false;
			}
		}
		// Display the name of the game with a big font, and display the options in a smaller font
		std::string title = "Stealin Gold", play = "Play Game", how = "How to play", quit = "Quit";
		Canvas::Fill(Rgba::BLACK);
		font.Print(title, TEXT_X(v_w - font.Width(title)/text_scale_x)/2, TEXT_Y(150));
		if (item == 0) {
			selected.Print(play, TEXT_X(v_w - selected.Width(play)/text_scale_x)/2, TEXT_Y(500));
		}
		else {
			selection.Print(play, TEXT_X(v_w - selection.Width(play)/text_scale_x)/2, TEXT_Y(500));
		}
		if (item == 1) {
			selected.Print(how, TEXT_X(v_w - selected.Width(how)/text_scale_x)/2, TEXT_Y(550));
		}
		else {
			grayed.Print(how, TEXT_X(v_w - grayed.Width(how)/text_scale_x)/2, TEXT_Y(550));
		}
		if (item == 2) {
			selected.Print(quit, TEXT_X(v_w - selected.Width(quit)/text_scale_x)/2, TEXT_Y(600));
		}
		else {
			selection.Print(quit, TEXT_X(v_w - selection.Width(quit)/text_scale_x)/2, TEXT_Y(600));
		}
		// Display Gold and King on each side of the title
		images.drawKing(1, 0, Vec2D(0,0), (int)counter);
		images.drawItem(0, Vec2D(v_w-64, v_h-64), (int)counter);
		Canvas::Refresh();
	}
	if (item == 0) return true;
	if (item == 1) return true; // There will be no How to Play in SpeedHack version, maybe
	if (item == 2) return false;
	return false;
}
